// mod parser;
use std::collections::{HashSet, HashMap};

use super::parser::{BAPair, BARule};

fn extract_base_expressions(pair: &BAPair, expressions: &mut HashSet<String>) {
  if pair.as_rule() == BARule::label {
    expressions.insert(pair.as_str().to_string());
  } else {
    for child_pair in pair.clone().into_inner() {
      extract_base_expressions(&child_pair, expressions);
    }
  }
}

fn extract_expressions<'a>(pair: &BAPair, expressions: &mut Vec<&BAPair>) {
  for child_pair in pair.clone().into_inner() {
    extract_expressions(&child_pair, expressions);
  }
  // if pair.as_rule() == BARule::expression {
  //   expressions.push(pair);
  // } else {
    
  // }
}

fn base_expression_combinations(base_expressions: &HashSet<String>) -> Vec<HashMap<String, bool>> {
  let combination_count = 2_u32.pow(base_expressions.len() as u32) as usize;
  let ordered_base_expressions: Vec<String> = base_expressions.clone().into_iter().collect();
  let mut combinations: Vec<HashMap<String, bool>> = Vec::with_capacity(combination_count);
  for n in 0..combination_count {
    let mut combination: HashMap<String, bool> = HashMap::with_capacity(base_expressions.len());
    for b in 0..base_expressions.len() {
      combination.insert(ordered_base_expressions[b as usize].clone(), (n >> b) % 2 == 1);
    }
    combinations.push(combination);
  }
  combinations
}

fn calculate_expression(values: HashMap<String, bool>, pair: BAPair) {

}

pub fn generate_truth_table(pair: &BAPair) {
  let mut base_expressions = HashSet::new();
  extract_base_expressions(pair, &mut base_expressions);
  log::debug!("Base expressions: {:?}", base_expressions);
  // log::debug!("Base expressions: {:?}", base_expressions.iter().product::<String>().collect::<Vec<_>>());

  let mut expressions  = Vec::new();
  extract_expressions(pair, &mut expressions);

  let combinations = base_expression_combinations(&base_expressions);
  log::debug!("{:#?}", combinations);
}